#include <iostream>

#include "microcode-long.hpp"

using namespace mc_long;
int main(int argc, char* argv[]) {

	{
		constexpr static auto set_33 = mc_long::instruction_record{
		    detail::str("SET 33"),
		    1,
		    {
		        {actions::act::r1R | actions::act::r1A | actions::act::r1i
		         | actions::act::r2L | actions::act::r2B | actions::act::r2i
		         | actions::act::RAA | actions::act::WBA},
		    }};
		const auto test = mc_long::parse_microcode_spec(R"EOF(
		"SET 33":
		   r1R,r1A,r1i,r2L,r2B,r2i,RAA,WBA;
		)EOF");

		assert(test == set_33);
	}
	{
		constexpr auto set_33 = instruction_record{
		    detail::str("SET 33"),
		    1,
		    {
		        {actions::act::r1R | actions::act::r1A | actions::act::r1i
		         | actions::act::r2L | actions::act::r2B | actions::act::r2i
		         | actions::act::RAA | actions::act::WBA},
		    }};
		const auto test = parse_microcode_spec(R"EOF(
		"SET 33":
		   r1RAi,r2LBi,RAA,w1-,w2-,C-,WBA;
		)EOF");
		assert(test == set_33); //*/
	}

	std::cout << "Hello World!" << std::endl;
	return 0;
}
